## grass 7.0.4

=== debian/changelog ===
grass (7.0.4-2) unstable; urgency=medium

  * Add patches by Alexis Bienvenüe to make the build reproducible.
    (closes: #825092)

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 24 May 2016 20:01:10 +0200

grass (7.0.4-1) unstable; urgency=medium

  * New upstream release.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 01 May 2016 16:09:45 +0200

grass (7.0.4~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Add template for x-grass7.
  * Drop explicit python-numpy dependency, included in ${python:Depends}
    via dh_numpy.
  * Have dh_python & dh_numpy act on specific packages only.
  * Use dynamic list of wxpython images files to move to use /usr/share.
  * Install additional icon sizes in hicolor icon theme.
  * Bump Standards-Version to 3.9.8, changes:
    additional icon sizes in hicolor theme.
  * Update copyright file, changes:
    - Add Jachym Ceppicky to copyright holders
    - Add license & copyright for mapcalc.tab.{c,h}
  * Drop patches applied upstream. Refresh remaining patches.
  * Add python-matplotlib to grass-gui Recommends for the several wxGUI tools.
  * Add patch to fix spelling errors.
  * Add python-termcolor to grass-core Recommends for g.search.modules.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 18 Apr 2016 23:57:37 +0200

grass (7.0.3-3) unstable; urgency=medium

  * Update dh_python2 override to call dh_numpy too.
  * Enable all hardening buildflags, except PIE (causes build failure).
  * Add patch to fix various spelling errors.
  * Don't delete /usr/lib/grass70/etc/license, not an extra license file
    and required for `grass --version`.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 29 Mar 2016 22:03:26 +0200

grass (7.0.3-2) unstable; urgency=medium

  * Require at least liblas 1.8.0-8 for GDAL 2.0 transition.
  * Add patch for various typos.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Mar 2016 14:36:07 +0100

grass (7.0.3-2~exp1) experimental; urgency=medium

  * Bump Standards-Version to 3.9.7, no changes.
  * Require at least libgdal-dev 2.0 for experimental builds.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 19 Feb 2016 15:29:10 +0100
